---
title: Reflect.getOwnPropertyDescriptor()
slug: Web/JavaScript/Reference/Global_Objects/Reflect/getOwnPropertyDescriptor
tags:
  - ECMAScript 2015
  - JavaScript
  - Method
  - Reference
  - Reflect
---
<div>{{JSRef}}</div>

<p><span class="seoSummary">The static <strong><code>Reflect.getOwnPropertyDescriptor()</code></strong> method is similar to {{jsxref("Object.getOwnPropertyDescriptor()")}}. It returns a property descriptor of the given property if it exists on the object, {{jsxref("undefined")}} otherwise.</span></p>

<div>{{EmbedInteractiveExample("pages/js/reflect-getownpropertydescriptor.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">Reflect.getOwnPropertyDescriptor(<var>target</var>, <var>propertyKey</var>)
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>target</var></code></dt>
 <dd>The target object in which to look for the property.</dd>
 <dt><code><var>propertyKey</var></code></dt>
 <dd>The name of the property to get an own property descriptor for.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A property descriptor object if the property exists in <code><var>target</var></code> object; otherwise, {{jsxref("undefined")}}.</p>

<h3 id="Exceptions">Exceptions</h3>

<p>A {{jsxref("TypeError")}}, if <code><var>target</var></code> is not an {{jsxref("Object")}}.</p>

<h2 id="Description">Description</h2>

<p>The <code>Reflect.getOwnPropertyDescriptor</code> method returns a property descriptor of the given property if it exists in the <code><var>target</var></code> object, {{jsxref("undefined")}} otherwise. The only difference to {{jsxref("Object.getOwnPropertyDescriptor()")}} is how non-object targets are handled.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_Reflect.getOwnPropertyDescriptor">Using Reflect.getOwnPropertyDescriptor()</h3>

<pre class="brush: js notranslate">Reflect.getOwnPropertyDescriptor({x: 'hello'}, 'x')
// {value: "hello", writable: true, enumerable: true, configurable: true}

Reflect.getOwnPropertyDescriptor({x: 'hello'}, 'y')
// undefined

Reflect.getOwnPropertyDescriptor([], 'length')
// {value: 0, writable: true, enumerable: false, configurable: false}
</pre>

<h3 id="Difference_to_Object.getOwnPropertyDescriptor">Difference to Object.getOwnPropertyDescriptor()</h3>

<p>If the <code><var>target</var></code> argument to this method is not an object (a primitive), then it will cause a {{jsxref("TypeError")}}. With {{jsxref("Object.getOwnPropertyDescriptor")}}, a non-object first argument will be coerced to an object at first.</p>

<pre class="brush: js notranslate">Reflect.getOwnPropertyDescriptor('foo', 0)
// TypeError: "foo" is not non-null object

Object.getOwnPropertyDescriptor('foo', 0)
// { value: "f", writable: false, enumerable: true, configurable: false }</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-reflect.getownpropertydescriptor', 'Reflect.getOwnPropertyDescriptor')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.Reflect.getOwnPropertyDescriptor")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Reflect")}}</li>
 <li>{{jsxref("Object.getOwnPropertyDescriptor()")}}</li>
</ul>
